:- consult([spil_schema]).

	
test:-
	spy_loader,
	write('Loading rules...'), nl,
	load_kb('spil.kb'),
	write('Rules loaded...'), nl, nl,
	write('Loading data...'), nl,
	load_data,
	write('Data loaded...'), nl, nl,
	write('Starting...'), nl,
	spy_tasks,
	fc,	
	write('Finished!'), nl, nl.

	

load_data :- 
	new([C1,[name([sulphuric_acid]),
	           ph([strong_acid]),
	   solubility([soluble]),
         spectrometry([sulphur]),
               colour([clear]),
                smell([none]),
              gravity([equal]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,
               
	new([C2,[name([hydrochloric_acid]),
	           ph([strong_acid]),
	   solubility([soluble]),
         spectrometry([none]),
               colour([clear]),
                smell([choking]),
              gravity([equal]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,  
               
	new([C3,[name([acetic_acid]),
	           ph([weak_acid]),
	   solubility([soluble]),
         spectrometry([none]),
               colour([clear]),
                smell([vinegar]),
              gravity([equal]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,  
               
	new([C4,[name([carbonic_acid]),
	           ph([weak_acid]),
	   solubility([soluble]),
         spectrometry([carbon]),
               colour([clear]),
                smell([none]),
              gravity([equal]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,  
               
	new([C5,[name([sodium_hydroxide]),
	           ph([strong_base]),
	   solubility([soluble]),
         spectrometry([sodium]),
               colour([clear]),
                smell([none]),
              gravity([equal]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,  
                                            
	new([C6,[name([chromogen_23]),
	           ph([strong_base]),
	   solubility([soluble]),
         spectrometry([none]),
               colour([red]),
                smell([none]),
              gravity([lighter]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,  
                 	
	new([C7,[name([aluminium_hydroxide]),
	           ph([weak_base]),
	   solubility([soluble]),
         spectrometry([none]),
               colour([white]),
                smell([none]),
              gravity([heavier]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,  
                 	
	new([C8,[name([rubidium_hydroxide]),
	           ph([weak_base]),
	   solubility([soluble]),
         spectrometry([metal]),
               colour([clear]),
                smell([none]),
              gravity([heavier]),
        radioactivity([present]),
               status([possible]) ]])=> chemical,
             
	new([C9,[name([petrol]),
	           ph([neutral]),
	   solubility([insoluble]),
         spectrometry([carbon]),
               colour([clear]),
                smell([none]),
              gravity([lighter]),
        radioactivity([none]),
               status([possible]) ]])=> chemical,
      
	new([C10,[name([transformer_oil]),
	            ph([neutral]),
	    solubility([insoluble]),
          spectrometry([carbon]),
                colour([clear]),
                 smell([none]),
               gravity([equal]),
         radioactivity([none]),
                status([possible]) ]])=> chemical,
             
        nl,nl,write('Chemicals loaded.'),nl,nl,

        
   	new([MS1,[locName([mon_station]),
   	           status([impossible]),
   	          focused([yes])
   	          ]])=> station,
  	           
   	new([M13,[locName([manhole13]),
   	           status([impossible]),
   	       downStream([MS1]),
   	          focused([no])]])=> manhole,
    	           
   	new([M12,[locName([manhole12]),
   	           status([impossible]),
   	       downStream([MS1]),
   	          focused([no])]])=> manhole,          
   	           
   	new([M11,[locName([manhole11]),
   	           status([impossible]),
   	       downStream([M13]),
   	          focused([no])]])=> manhole,          
   	           
   	new([M10,[locName([manhole10]),
   	           status([impossible]),
   	       downStream([M12]),
   	          focused([no])]])=> manhole,          
  
    	new([M9,[locName([manhole9]),
   	          status([impossible]),
   	      downStream([M12]),
   	         focused([no])]])=> manhole,          
  
    	new([M8,[locName([manhole8]),
   	          status([impossible]),
   	      downStream([M13]),
   	         focused([no])]])=> manhole,          
  
    	new([M7,[locName([manhole7]),
   	          status([impossible]),
   	      downStream([M11]),
   	         focused([no])]])=> manhole,          
  
    	new([M6,[locName([manhole6]),
   	          status([impossible]),
   	      downStream([M11]),
   	         focused([no])]])=> manhole,          
  
    	new([M5,[locName([manhole5]),
   	          status([impossible]),
   	      downStream([M10]),
   	         focused([no])]])=> manhole,          
  
     	new([M4,[locName([manhole4]),
   	          status([impossible]),
   	      downStream([M10]),
   	         focused([no])]])=> manhole,          
  
     	new([M3,[locName([manhole3]),
   	          status([impossible]),
   	      downStream([M9]),
   	         focused([no])]])=> manhole,          
  
     	new([M2,[locName([manhole2]),
   	          status([impossible]),
   	      downStream([M9]),
   	         focused([no])]])=> manhole,          
  
     	new([M1,[locName([manhole1]),
   	          status([impossible]),
   	      downStream([M9]),
   	         focused([no])]])=> manhole,          

     	new([_S1,[locName([store1]),
   	          status([impossible]),
   	      downStream([M1]),
   	         focused([no]),
   	       chemicals([C1,C9]) ]])=> store,          
 
     	new([_S2,[locName([store2]),
   	          status([impossible]),
   	      downStream([M2]),
   	         focused([no]),
   	       chemicals([C2,C3]) ]])=> store,          
  
     	new([_S3,[locName([store3]),
   	          status([impossible]),
   	      downStream([M3]),
   	         focused([no]),
   	       chemicals([C8,C10]) ]])=> store,          
 
     	new([_S4,[locName([store4]),
   	          status([impossible]),
   	      downStream([M4]),
   	         focused([no]),
   	       chemicals([C3,C4,C9]) ]])=> store,          
 
     	new([_S5,[locName([store5]),
   	          status([impossible]),
   	      downStream([M5]),
   	         focused([no]),
   	       chemicals([C1,C6,C9]) ]])=> store,          
 
     	new([_S6,[locName([store6]),
   	          status([impossible]),
   	      downStream([M6]),
   	         focused([no]),
   	       chemicals([C4,C7,C10]) ]])=> store,          
  
     	new([_S7,[locName([store7]),
   	          status([impossible]),
   	      downStream([M7]),
   	         focused([no]),
   	       chemicals([C1,C2]) ]])=> store,          
  
     	new([_S8,[locName([store8]),
   	          status([impossible]),
   	      downStream([M8]),
   	         focused([no]),
   	       chemicals([C3,C4,C5]) ]])=> store,          

  
  	nl,nl,write('Topology loaded.'),nl,nl,
 
       
        % ph  -  (0.0, 14.0)
	new([_,[ mname([ph]),
	         value([7.0])]])=>measurement, 
        
        % solubility - {soluble, insoluble}
	new([_,[ mname([solubility]),
	         descr([insoluble])]])=>measurement, 
         
        % spectrometry - {carbon, sulphur, metal, sodium, none}
	new([_,[ mname([spectrometry]),
	         descr([carbon])]])=>measurement, 
	
        % colour - {white, red, clear}
	new([_,[ mname([colour]),
	         descr([clear])]])=>measurement, 
	         
        % smell - {choking, vinegar, none}
	new([_,[ mname([smell]),
	         descr([none])]])=>measurement, 
	         
        % gravity - (0.9, 1.1)
	new([_,[ mname([gravity]),
	         value([1.0])]])=>measurement, 
	         
        % radioactivity - {present, none}
	new([_,[ mname([radioactivity]),
	         descr([none])]])=>measurement, 
	
        nl,nl,
        write('Measurements loaded.'),
        nl,nl.
	
