:- [schema].

describe_all(Class) :- 
	get(A) => Class,
	describe => A,
	fail.
describe_all(_).

% OK
test1(L) :- 
	transform2("if E1@emp(name='Mike', salary:S1, salary.manager>S1) then delete => E1", L).

test1a(L):- 
	transform2("if E1@emp(name = 'Mike', salary : S1, salary . manager>S1) then delete => E1", L).

test1b(L):- 
	transform2("if E1@emp then delete => E1", L).

% OK
test2(T) :- 
	parse("if E1@emp(name='Mike', salary:S1, salary.manager>S1) then delete => E1", T).
/* The above should be translated to :
   	if E1@emp(name='Mike', salary:S1, manager:XX1) and
	   XX1@emp(salary>S1)
	then delete => E1
*/

% OK
test3(T) :- 
	parse("if E1@emp(name='Mike', salary:S1<20) then update_salary([S1,20]) => E1", T).
% OK
test4(T) :- 
	parse("if E1@emp(name='Mike', salary:S1, salary.manager.manager>S1) then delete => E1", T).
% OK
test5(T) :- 
	parse("if E1@emp(name='Mike', salary:S1<20) then update_salary([S1,20]) => E2", T).
% OK
test6(T) :- 
	parse("if E1@emp(name='Mike', age<20;>60) then delete => E1", T).
% OK
test7(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.
% OK
test8(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1<20) then update_salary([S1,20]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.
% OK
test8A(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary>=20, age:A<30)  and prolog{A1 is A + 1} then update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.
% OK
test9(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, name.manager='John') and prolog{S2 is 1.1 * S1} then  update_salary([S1,S2]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.
% OK
test10(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and E2@emp(name='John', salary:S2>S1) and prolog{ NewSal is 1.1 * S2} then update_salary([S1,NewSal]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

test11(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager.manager>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.
/* The above is translated to:
       "if E1@emp(name='Mike', salary:S1, manager:XX1) and
           XX1@emp(manager:XX2) and
           XX2@emp(salary>S1) 
        then delete => E1"
*/

% 12 OK
test12(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', age<20;>60) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

% OK
test13(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', age>60) and E2@emp(name='John', age<20) then write([E1,' is the father of ',E2]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

% OK
test14(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(salary>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

% OK
test15(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(name='John', salary>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

% OK
test16(R) :- 
	new([R,[rule(["if E1@emp(name='John',salary:S1) and E2@emp(salary:S2) then update_salary([S2,S1]) => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

% OK
test17(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(name='John', salary>S1) and not E3@emp(name='Jim', salary<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.


% OK
test18(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(salary.manager>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.


/*    "if E1@emp(name='Mike', salary:S1) and \
          not E2@emp(salary.manager>S1) \
       then delete => E1"

is transformed into:

       "if E1@emp(name='Mike', salary:S1) and \
           not ( E2@emp(manager:XX1) and \
                 XX1@emp(salary>S1) )
       then delete => E1"
*/




test19(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not ( E2@emp(name='John', salary>S1) and E3@emp(name='Jim', salary<S1) ) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.



/* The following tests test the run-time component of DEVICE */

% OK
test20([E,R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1<20) then update_salary([S1,20]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	start_here,
	new([E,[name(['Mike']),salary([10])]]) => emp,
	write('Before EOT:'), nl,
	describe => E,
	fc,
	write('After EOT:'), nl,
	describe => E.
	

/*
	new([E,[name(['Mike']),salary([30])]]) => emp.
	new([E3,[name(['John']),salary([10])]]) => emp,
	new([E4,[name(['Jack']),salary([50])]]) => emp.
*/

% OK
test21([E,[R1,R2]]) :- 

	new([R1,[rule(["if E1@emp(name='Mike', salary:S1<20) then update_salary([S1,20]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([R2,[rule(["if E1@emp(name='Mike', salary>=20, age:A<30) and prolog{A1 is A + 1} then update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([10]),age([25])]]) => emp,
	write('Before fc:'), nl,
	describe => E,
	fc,
	write('After fc:'), nl,
	describe => E.
	
% OK
test22([E,[R1,R2]]) :- 
	new([R1,[rule(["if E1@emp(name='Mike', age:A<20) and prolog{A1 is A + 1} then write(['Mike is ',A,' years old.']), nl, update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([R2,[rule(["if E1@emp(name='Mike', age>15, salary:S<30) and prolog{S1 is 2 * S} then write(['Mike earns ',S,' salary.']), nl, update_salary([S,S1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([17]),age([18])]]) => emp,
	write('Before fc:'), nl,
	describe => E,
	fc,
	write('After fc:'), nl,
	describe => E.


test23([E,[R1,R2]]) :- 
	new([R1,[rule(["if E1@emp(name='Mike', age:A<20) and prolog{A1 is A + 1} then write(['Mike is ',A,' years old.']), nl, update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([R2,[rule(["if E1@emp(name='Mike', age:A>15, salary:S<30) and prolog{S1 is 2 * S, A1 is A * 2} then write(['Mike earns ',S,' salary.']), nl, update_salary([S,S1]) => E1, update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([17]),age([18])]]) => emp,
	write('Before fc:'), nl,
	describe => E,
	start_here,
	fc,
	write('After fc:'), nl,
	describe => E.

test23b([E,[R2]]) :- 
	new([R2,[rule(["if E1@emp(name='Mike', salary:S<30) and prolog{S1 is 2 * S} then write(['Mike earns ',S,' salary.']), nl, update_salary([S,S1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([17])]]) => emp,
	write('Before fc:'), nl,
	describe => E,
	fc,
	write('After fc:'), nl,
	describe => E.
	
% This test will find out if the recency conflict resolution criterion works!
test24([E1,[R1,R2]]) :- 
	new([R1,[rule(["if E1@emp(name='Mike', age>15, salary<30) then new([_,[name(['John']),salary([25])]]) => emp"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([R2,[rule(["if E1@emp(name:N, salary:S<30) and prolog{S1 is 2 * S} then write([N,' earns ',S,' salary.']), nl, update_salary([S,S1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']),salary([17]),age([19])]]) => emp,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK!!!!
test25([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([20])]]) => emp,
	new([E2,[name(['Mike']), salary([25]), manager([E1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test25_spy([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	get_event(Event) => R,
	spy_event(Event),
	start_here,
	new([E1,[name(['John']), salary([20])]]) => emp,
	new([E2,[name(['Mike']), salary([25]), manager([E1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).
	
% OK
test25a([[E1,E2,E3],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, manager:M) and E2@emp(name='John', salary<S1, manager:M) and M@emp(salary<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Jim']), salary([20])]]) => emp,
	new([E2,[name(['Mike']), salary([25]), manager([E1])]]) => emp,
	new([E3,[name(['John']), salary([23]), manager([E1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test26([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager>S1, name.manager='John') and prolog{S2 is 2 * S1} then update_salary([S1,S2]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([30])]]) => emp,
	new([E2,[name(['Mike']), salary([25]), manager([E1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test27([[E1,E2],R]) :-
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and E2@emp(name='John', salary:S2>S1) and prolog{NewSal is 2 * S2} then update_salary([S1,NewSal]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	get_event(Event) => R,
	describe => Event,
	new([E1,[name(['Mike']), salary([40])]]) => emp,
	new([E2,[name(['John']), salary([50])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test27a([[E1,E2],R]) :-
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and E2@emp(name='John', salary>S1) and prolog{NewSal is 2 * S1} then write(['Salary of ',E1,' is ',S1]), nl, update_salary([S1,NewSal]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([90])]]) => emp,
	new([E2,[name(['Mike']), salary([20])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).


test28([[E1,E2,E3],R]) :-
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager.manager<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([20])]]) => emp,
	new([E2,[name(['Jim']), salary([30]), manager([E1])]]) => emp,
	new([E3,[name(['Mike']), salary([25]), manager([E2])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test28a([[E1,E2,E3,E4],R]) :-
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager.manager.manager<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([20])]]) => emp,
	new([E2,[name(['Jim']), salary([30]), manager([E1])]]) => emp,
	new([E3,[name(['George']), salary([28]), manager([E2])]]) => emp,
	new([E4,[name(['Mike']), salary([25]), manager([E3])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test29([E,R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', age<20;>60) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([10]),age([65])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test30([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', age>60) and E2@emp(name='John', age<20) then write([E1,' is the father of ',E2]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']), age([70])]]) => emp,
	new([E2,[name(['John']), age([18])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).


% OK
test31([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(salary>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([90])]]) => emp,
	new([E2,[name(['Mike']), salary([100])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test31a([[E1,E2],R]) :- 
	new([R,[rule(["if unique(E1)@emp(name:N,salary:S1) and not E2@emp(salary>S1) then write_list(['Name:',N]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	spy_cs(mm_production_rule),
	spy_event(1#mm_negative_event),
	spy_event(0#mm_positive_event),
	new([E1,[name(['John']), salary([90])]]) => emp,
	start_here,
	new([E2,[name(['Mike']), salary([100])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp), nl, nl,
	fc,
	nl, write('After fc:'), nl.

test31b([[E1,E2],R]) :- 
	new([R,[rule(["if unique(E1)@emp(name:N,salary.manager:S1) and not E2@emp(salary>S1) then write_list(['Name:',N]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	spy_cs(mm_production_rule),
	spy_event(0#mm_positive_event),
	spy_event(1#mm_positive_event),
	spy_event(2#mm_negative_event),
	new([E1,[name(['John']), salary([150])]]) => emp,
	start_here,
	new([E2,[name(['Mike']), salary([100]), manager([E1])]]) => emp,
	new([E3,[name(['Nick']), salary([200])]]) => emp,
	new([E4,[name(['George']), salary([80]), manager([E3])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp), nl, nl,
	fc,
	nl, write('After fc:'), nl.

test31c([[E1,E2],R]) :- 
	new([R,[rule(["if unique(E1)@emp(name:N,salary.manager:S1) and not E2@emp(salary.manager>S1) then write_list(['Name:',N]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	spy_cs(mm_production_rule),
	spy_event(0#mm_positive_event),
	spy_event(1#mm_positive_event),
	spy_event(2#mm_negative_event),
	new([E1,[name(['John']), salary([150])]]) => emp,
	start_here,
	new([E2,[name(['Mike']), salary([100]), manager([E1])]]) => emp,
	new([E3,[name(['Nick']), salary([200])]]) => emp,
	new([E4,[name(['George']), salary([80]), manager([E3])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp), nl, nl,
	fc,
	nl, write('After fc:'), nl.

% OK
test32a([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(name='John', salary>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([110])]]) => emp,
	new([E2,[name(['Mike']), salary([100])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp),
	update_salary([110,90]) => E1,
	nl, write('After update, before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After update, after fc:'), nl,
	describe_all(emp).

% OK
test32b([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(name='John', salary>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([90])]]) => emp,
	new([E2,[name(['Mike']), salary([100])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test32c([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(name='John', salary>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Nick']), salary([110])]]) => emp,
	new([E2,[name(['Mike']), salary([100])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test33([[E1,E2],R]) :- 
	new([R,[rule(["if E1@emp(name:N='John',salary:S1) and E2@emp(name\\=N,salary:S2) and prolog{Age is S2 - S1} then put_age([Age]) => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']), salary([90])]]) => emp,
	new([E2,[name(['Mike']), salary([100])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test34([[E1,E2,E3],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(name='John', salary>S1) and not E3@emp(name='Jim', salary<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']), salary([100])]]) => emp,
	new([E2,[name(['John']), salary([110])]]) => emp,
	new([E3,[name(['Jim']), salary([90])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

% OK
test34b([[E1,E2,E3],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(name='John', salary>S1) and not E3@emp(name='Jim', salary<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']), salary([100])]]) => emp,
	new([E2,[name(['John']), salary([90])]]) => emp,
	new([E3,[name(['Jim']), salary([110])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test35([[E1,E2,XX1],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(salary.manager>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']), salary([100])]]) => emp,
	new([XX1,[name(['John']), salary([110])]]) => emp,
	new([E2,[name(['Jim']), salary([90]), manager([XX1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test35b([[E1,E2,XX1],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not E2@emp(salary.manager>S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']), salary([100])]]) => emp,
	new([XX1,[name(['John']), salary([95])]]) => emp,
	new([E2,[name(['Jim']), salary([90]), manager([XX1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).


test36([[E1,E2,E3],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not ( E2@emp(name='John', salary>S1) and E3@emp(name='Jim', salary<S1) ) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']), salary([100])]]) => emp,
	new([E2,[name(['John']), salary([110])]]) => emp,
	new([E3,[name(['Jim']), salary([90])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test36b([[E1,E2,E3],R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1) and not ( E2@emp(name='John', salary>S1) and E3@emp(name='Jim', salary<S1) ) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['Mike']), salary([100])]]) => emp,
	new([E2,[name(['John']), salary([80])]]) => emp,
	new([E3,[name(['Jim']), salary([90])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).


test37(T) :- 
	parse("if mm_production_rule(task=start) then new([E1,[name(['Mike']), salary([100])]]) => emp", T).
test37b(T) :- 
	parse("if mm_production_rule(task=start) then new([_,[name(['Mike']), salary([100])]]) => emp", T).
	
test38(R) :- 
	new([R,[rule(["if mm_production_rule(task=start) then new([E1,[name(['Mike']), salary([100])]]) => emp"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

%% Compilation error
test38b(R) :- 
	new([R,[rule(["if mm_production_rule(task=start) then new([_,[name(['Mike']), salary([100])]]) => emp"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

test39(R) :- 
	new([R,[rule(["if mm_production_rule(task=start) then new([_,[name(['Mike']), salary([100])]]) => emp"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	put_task([start]) => mm_production_rule,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).



% The following tests an extension to DEVICE that adds the ability
% to call an arbitrary prolog goal within the condition. First only the
% parser is tested.
% OK
test40(T) :- 
	parse("if E1@emp(name='Mike', salary>=20, age:A<30) and prolog{A1 is A + 1} then update_age([A,A1]) => E1",T).

% This tests the parser's ability to detect non-safety of a rule
% when the action contains a variable that was not declared in the
% condition or the prolog goal
% OK
test40a(T) :- 
	parse("if E1@emp(name='Mike', salary>=20, age:A<30) and prolog{A1 is A + 1} then update_age([A,A1]) => E2",T).

% This and the next example test the parser's ability to detect non-safety of a rule
% when the prolog goal contains a variable that was neither declared in the
% condition nor it is used in the action
% NOTICE: These are not correct safety restrictions! See Ullman
% OK
test40b(T) :- 
	parse("if E1@emp(name='Mike', salary>=20, age:A<30) and prolog{A1 is A2 + 1} then update_age([A,A1]) => E1",T).
% OK
test40c(T) :- 
	parse("if E1@emp(name='Mike', salary>=20, age:A<30) and prolog{A1 is A + 1, A2 is A * 2} then update_age([A,A1]) => E1",T).

% This tests the rule compilation with the 'prolog' construct
% OK
test41(R) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary>=20, age:A<30) and prolog{A1 is A + 1} then update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

% This tests the rule's run-time with the 'prolog' construct
% OK
test42([E,R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary>=20, age:A<30) and prolog{A1 is A + 1} then update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([30]),age([27])]]) => emp,
	write('Before fc:'), nl,
	describe => E,
	fc,
	write('After fc:'), nl,
	describe => E.

% OK
test43([E,R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S>=20, age:A<30) and prolog{Q is S - A, Q < 5, A1 is A + 1} then update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([30]),age([27])]]) => emp,
	write('Before fc:'), nl,
	describe => E,
	fc,
	write('After fc:'), nl,
	describe => E.

% OK
test43a([E,R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S>=20, age:A<30) and prolog{Q is S - A, Q < 5, A1 is A + 1} then update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([35]),age([27])]]) => emp,
	write('Before fc:'), nl,
	describe => E,
	fc,
	write('After fc:'), nl,
	describe => E.

% The following tests, test the insertion of a rule in a non-empty database
% OK
test44([E,R])  :-
	new([E,[name(['Mike']),salary([10])]]) => emp,
	write('Before inserting the rule:'), nl,
	describe => E,
	new([R,[rule(["if E1@emp(name='Mike', salary:S1<20) then update_salary([S1,20]) => E1"]),
	        is_it_enabled([yes])
            ]]) => mm_production_rule,
	write('Before EOT:'), nl,
	describe => E,
	fc,
	write('After EOT:'), nl,
	describe => E.

% OK  !!!!!!!!
test45([E1,E2,E3,E4,R]) :- 
	new([E1,[name(['Mike']),salary([10]),age([17])]]) => emp,
	new([E2,[name(['Nick']),salary([25]),age([27])]]) => emp,
	new([E3,[name(['Jack']),salary([27]),age([20])]]) => emp,
	new([E4,[name(['John']),salary([30]),age([37])]]) => emp,
	new([R,[rule(["if E1@emp(name:N, salary>=20, age:A<30) and prolog{A1 is A + 1} then write(['The age of ',N,' is updated!']), nl, update_age([A,A1]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	write('Before fc:'), nl,
	describe_all(emp),
	fc,
	write('After fc:'), nl,
	describe_all(emp).


% OK
test46([[E1,E2],R]) :- 
	new([E1,[name(['John']), salary([20])]]) => emp,
	new([E2,[name(['Mike']), salary([25]), manager([E1])]]) => emp,
	new([R,[rule(["if E1@emp(name='Mike', salary:S1, salary.manager<S1) then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).


%The following tests test the new and delete events when the class pattern does not contain
%attribute patterns!

test47([R]) :- 
	new([R,[rule(["if E1@emp then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.

test47a(R) :- 
	parse("if E1@emp then delete => E1",R).

test48([E1,R]) :- 
	new([R,[rule(["if E1@emp then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	start_here,
	new([E1,[name(['John'])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test49([E1,P1,R]) :- 
	new([R,[rule(["if E1@emp then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	start_here,
	new([E1,[name(['John'])]]) => emp,
	new([P1,[name(['Nick'])]]) => person,
	nl, write('Before fc:'), nl,
	describe_all(person),    % Includes emp instances!
	fc,
	nl, write('After fc:'), nl,
	describe_all(person).

% To run this test (and the rest 50x ones) you should change the type of manager slot 
% from emp to person in schema.pl
test50([E1,P1,R]) :- 
	new([R,[rule(["if E1@emp(manager:P1) and not P1@person then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	start_here,
	new([P1,[name(['Nick'])]]) => person,
	new([E1,[name(['John']),manager([P1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(person),    % Includes emp instances!
	fc,
	nl, write('After fc:'), nl,
	describe_all(person).

% This test does not run because when the message delete is sent to the person,
% ADAM removes the OID of the person-to-be-deleted from the slot manager of emp,
% therefore, when the anti-signal is evoked at the negative input of the negative event
% there are no tokens left at the left (positive) memory to join with!
test50a([E1,P1,R]) :- 
	new([R,[rule(["if E1@emp(manager:P1) and not P1@person then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	start_here,
	new([P1,[name(['Nick'])]]) => person,
	new([E1,[name(['John']),manager([P1])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(person),    % Includes emp instances!
	fc,
	nl, write('After fc:'), nl,
	describe_all(person),
	adam_spy(delete),
	adam_spy(delete_manager),
	delete => P1,
	nl, write('After delete:'), nl,
	describe_all(person),
	fc,
	nl, write('After delete and fc:'), nl,
	describe_all(person).

test50b([E1,F1,R]) :- 
    new([foo,[
	slot(slot_tuple(name,global,single,total,string)),
	slot(slot_tuple(age,global,single,optional,integer))
    ]]) => mm_entity_class,
	new([R,[rule(["if E1@emp(name='John') and not F1@foo then delete => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([F1,[name(['Nick'])]]) => foo,
	new([E1,[name(['John'])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(foo),   
	describe_all(emp),   
	fc,
	nl, write('After fc:'), nl,
	describe_all(foo),   
	describe_all(emp),   
	start_here,
	delete => F1,
	nl, write('After delete:'), nl,
	describe_all(foo),   
	describe_all(emp),   
	fc,
	nl, write('After delete and fc:'), nl,
	describe_all(foo),   
	describe_all(emp).

% OK 
test51([E1,R]) :- 
	new([R,[rule(["if E1@emp(name:X,age:Y) then write([X,Y]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']),age([38])]]) => emp,
	fc.
	
% OK
test52([E1,R]) :- 
	new([R,[rule(["if E1@emp(name:X,age:Y,phone:Z) then write([X,Y,Z]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']),age([38]),phone([8145])]]) => emp,
	fc.
	
% OK
test53([E1,R]) :- 
	new([R,[rule(["if E1@emp(name:X,age:Y,phone:Z,salary:W) then write([X,Y,Z,W]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']),age([38]),phone([8145]),salary([400000])]]) => emp,
	fc.
% OK????
test54([E1,F1,F2,R]) :- 
    new([foo,[
	slot(slot_tuple(name,global,single,total,string)),
	slot(slot_tuple(age,global,single,optional,integer))
    ]]) => mm_entity_class,
	new([R,[rule(["if E1@emp(name:X,age:Y,phone:Z,salary:W) and P1@foo(age=Y) and P2@foo(name=X) then write([E1,X,Y,Z,W]), nl, write([P1,Y]), nl, write([P2,X]), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']),age([38]),phone([8145]),salary([400000])]]) => emp,
	new([F1,[name(['Nick']),age([38])]]) => foo,
	new([F2,[name(['John']),age([47])]]) => foo,
	fc.
% OK
test55([F1,R]) :- 
	new([R,[rule(["if not E1@emp(name='John',age=Y) and E2@emp(name='Nick',age:Y) then delete => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	%new([E1,[name(['John']),age([38])]]) => emp,
	new([F1,[name(['Nick']),age([38])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),   
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).
% OK
test55a([F1,R]) :- 
	new([R,[rule(["if E2@emp(name='Nick',age:Y) and not E1@emp(name='John',age=Y) then delete => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	%new([E1,[name(['John']),age([38])]]) => emp,
	new([F1,[name(['Nick']),age([38])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),   
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).
% OK
test56([E1,E2,R]) :- 
	new([R,[rule(["if E1@emp(age=Y,name\\='Nick') and E2@emp(age:Y,name='Nick') then delete => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E1,[name(['John']),age([38])]]) => emp,
	new([E2,[name(['Nick']),age([38])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),   
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).
% OK
test57([E1,E2,E3,E4,R]) :- 
	new([R,[rule(["if E1@emp(name:X,age>30,salary>120000) and E2@emp(name=X,age:Y1,salary>100000) and E3@emp(name='John',age=Y1,salary:Z2) and E4@emp(name='Nick',age<50,salary=Z2) then delete => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	%start_here,
	new([E1,[name(['Jim']),age([38]),salary([150000])]]) => emp,
	new([E2,[name(['Jim']),age([29]),salary([110000])]]) => emp,
	new([E3,[name(['John']),age([29]),salary([100000])]]) => emp,
	new([E4,[name(['Nick']),age([28]),salary([100000])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),   
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test58([E,R]) :- 
	new([R,[rule(["if E@emp(name='Jack', age<30, promotion_year>=1990) then  nl, nl, write('Jack'), nl, nl"]),
		       is_it_enabled([yes])
               ]]) => mm_production_rule,
	%start_here,
	new([E,[name(['Jack']),age([29]),promotion_year([1989])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),   
	fc,
	put_promotion_year([1991]) => E,
	nl, write('After 1st update:'), nl,
	describe_all(emp),
	fc,
	put_promotion_year([1992]) => E,
	nl, write('After 2nd update:'), nl,
	describe_all(emp),
	fc.

		
% OK
test59([E,R]) :- 
	new([R,[rule(["if E1@emp(name='Mike', salary:S1<20) then update_salary([S1,20]) => E1"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	new([E,[name(['Mike']),salary([10])]]) => emp,

	update_is_it_enabled([yes,no]) => R,
	update_salary([20,10]) => E,
	nl, write('Before fc (2nd time):'), nl,
	describe_all(emp),   
	fc,
	nl, write('After fc (2nd time):'), nl,
	describe_all(emp),
	start_here,
	update_is_it_enabled([no,yes]) => R,
	fc,
	nl, write('After fc (3rd time):'), nl,
	describe_all(emp).

test60(L) :- 
	transform2("if unique(B1)@brick(size:S1, place=heap) and not B2@brick(size>S1, place=heap) then write_list([B1,S1]), nl", L).

test61([R,L1,L2]) :- 
   new([location,[
   	slot(slot_tuple(locName,global,single,optional,string)),
   	slot(slot_tuple(status,global,single,optional,string)),
   	slot(slot_tuple(downStream,global,single,optional,location))
   ]]) => mm_entity_class,	
   new([R,[rule(["if Loc1@location(downStream=L, status=possible) and Loc2@location(downStream=L, status=possible)\\=Loc1 then write_list([Loc1,Loc2]), nl"]),
	        is_it_enabled([yes])
   ]]) => mm_production_rule,
   new([L,[locName(['Store 0']),status([possible])]]) => location,
   new([L1,[locName(['Manhole 1']),status([possible]),downStream([L])]]) => location,
   new([L2,[locName(['Manhole 2']),status([possible]),downStream([L])]]) => location,
	nl, write('Before fc:'), nl,
	describe_all(location),   
	nl, nl,
	fc,
	nl, write('After fc:'), nl.

test61a([R,L1,L2]) :- 
   new([location,[
   	slot(slot_tuple(locName,global,single,optional,string)),
   	slot(slot_tuple(status,global,single,optional,string)),
   	slot(slot_tuple(downStream,global,single,optional,location))
   ]]) => mm_entity_class,	
   new([R,[rule(["if Loc1@location(downStream=L, status=possible) and Loc2@location(downStream=L, status=possible) then write_list([Loc1,Loc2]), nl"]),
	        is_it_enabled([yes])
   ]]) => mm_production_rule,
   new([L,[locName(['Store 0'])]]) => location,
   new([L1,[locName(['Manhole 1']),status([possible]),downStream([L])]]) => location,
   new([L2,[locName(['Manhole 2']),status([possible]),downStream([L])]]) => location,
	nl, write('Before fc:'), nl,
	describe_all(location),   
	nl, nl,
	fc,
	nl, write('After fc:'), nl.
	

test62([[E1,E2],R]) :- 
	new([R,[rule(["if mm_production_rule(task=start) and E1@emp(name='Mike', salary:S) and E2@emp(name='John', salary>S) then write_list([E1,E2]), nl, delete => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	spy_cs(all),
	spy_event(5#mm_positive_event),
	spy_event(6#mm_positive_event),
	new([E1,[name(['Mike']), salary([110])]]) => emp,
	new([E2,[name(['John']), salary([150])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test62a([[E1,E2],R]) :- 
	new([R,[rule(["if mm_production_rule(task=start) and E1@emp(name='Mike', salary:S) and E2@emp(name='John', salary\\=S) then write_list([E1,E2]), nl, delete => E2"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule,
	spy_cs(all),
	spy_event(5#mm_positive_event),
	spy_event(6#mm_positive_event),
	new([E1,[name(['Mike']), salary([110])]]) => emp,
	new([E2,[name(['John']), salary([150])]]) => emp,
	nl, write('Before fc:'), nl,
	describe_all(emp),
	fc,
	nl, write('After fc:'), nl,
	describe_all(emp).

test63([[E1,E2],R]) :- 
	new([R,[rule(["if mm_production_rule(task=start) and not E1@emp(name='Mike', salary>200) then write(ok), nl"]),
	        is_it_enabled([yes])
               ]]) => mm_production_rule.
